var Ar;
angular.module('starter.controllers', ['ngCordova', 'starter.services'])

.constant('$ionicLoadingConfig', {
  template: '<i class="icon ion-loading-a"></i> 加载中..'
})

.constant('BILIPATH', 'Android/data/tv.danmaku.bili/')

.controller('MainCtrl', function($scope, $ionicPlatform, $ionicLoading, $localstorage, BILIPATH) {

	$scope.overflowScroll = true;

	$ionicPlatform.ready(function() {
	  	if(window.device && parseInt(device.version) < 4) {
			$scope.overflowScroll = false;
		}
	});

	$scope.Loading = {
		show: function() {
		    $ionicLoading.show(); //options default to values in $ionicLoadingConfig
	  	},
	  	hide: function() {
	  		$ionicLoading.hide();
	  	}
	}

	$scope.biliPath = $localstorage.get("biliPath", BILIPATH);
})

.controller('HomeCtrl', function($scope) {
	$scope.search = function() {
		$scope.Loading.show();
	}
})

.controller('SearchDetailCtrl', function($scope, $stateParams, Biliapi, detailInfo) {

	$scope.Loading.hide();

	$scope.avid = $stateParams.avid || 1606322;

	$scope.info = {
		author: "",
		pic: null,
		title: "",
		play: 0,
		video_review: 0,
		description: "...",
		pages: 0,
		list: []
	};

	$scope.selected = {
		quality: {}
	};

	var setInfo = function(detailInfo) {
		if (!detailInfo.error && detailInfo.data.list) {
			$scope.info = detailInfo.data;
			var list = $scope.info.list;
			if (list.length == 1 && !list[0].part) {
				$scope.info.list[0].part = $scope.info.title;
			};
		}
	}
	
	$scope.refresh = function() {
		Biliapi.getInfo($scope.avid).then(setInfo)
	};

	$scope.goBili = function() {
		window.open('abiliav://av' + $scope.avid, '_system')
	};

	setInfo(detailInfo);
})

.controller('SelectQualityCtrl', function($scope) {
	
    $scope.model = [{
        id: 400,
        name: '跑分'
    }, {
        id: 300,
        name: '精美'
    }, {
        id: 200,
        name: '良心'
    }, {
        id: 100,
        name: '渣'
    }];

    $scope.selected.quality = $scope.model[2];
})

.controller('PageListCtrl', function($scope, $cordovaToast, Archive) {
	
	/*
	var setItem = function(avInfos) {

		var arr = avInfos.filter(function(avInfo) {
		    return avInfo.avid == $scope.avid ?avInfo : false;
		});

		var item = arr[0];
		console.log(item)
	}

	Archive.list().then(setItem)
	*/

	$scope.add = function(index) {
		var item = $scope.info.list[index];

		var quality = $scope.selected.quality.id;
		Archive.add($scope.avid, $scope.info, index, quality)
			.then(function(uri) {
				item.hasAdd = true;
				item.dirPath = uri;
				return $cordovaToast.show('添加成功', 'short', 'center')
			});
	};

	$scope.import = function(index) {
		var item = $scope.info.list[index];

		window.plugins.mfilechooser.open([], function(filePath) {
			Archive.import(filePath, item.dirPath)
				.then(function() {
					return $cordovaToast.show('导入成功', 'short', 'center')
				});
		}, function(error) {
		    console.log(error)
		});
		
	};

	$scope.downLoad = function() {

	};

	$scope.downLoadAll = function() {

	};
	
})

.controller('ArchiveCtrl', function($scope, $state, Archive, $timeout) {

	$scope.looping = false;

	$scope.items = [];

	var setItems = function(avInfos) {
		$scope.items = avInfos.sort(function(a, b) {
			//按 avid 倒叙排列 
			return a.avid > b.avid ? -1 : 1;
		})
		.map(function(avInfo) {
			return [{isTitle: avInfo.title, avid: avInfo.avid}].concat(avInfo.pages)
		})
		.reduce(function(previous, current) {
			return previous.concat(current);
		})

		$scope.looping = false;
	}

	var timer = null;
	var setFinal = function() {
		timer = $timeout(function() {
					$scope.looping = false; 
				}, 2000)
	}
	
	$scope.refresh = function() {
		$scope.looping = true;
		Archive.refresh().then(setItems).finally(setFinal);
	};

	$scope.go = function(avid) {
		$state.go("tab.search-detail", {"avid": avid})
		$scope.Loading.show();
	}
	Ar = Archive;
	Archive.list().then(setItems).finally(setFinal);

    $scope.$on("$destroy", function(event) {
	    	if (timer) {
	    		$timeout.cancel(timer);
	    	};
        }
    );
})

.controller('ChooseDirCtrl', function($scope, $localstorage, $filechooser, $cordovaToast) {

	$scope.chooseDir = function() {
		$filechooser.get()
			.then(function(fileUri) {
				var patt = /tv.danmaku.bili/;
	            if (patt.test(fileUri)) {
	            	var dirUri = fileUri.match(/\S+tv.danmaku.bili\//)[0];
	            	$localstorage.set('biliPath', dirUri);
	            	$scope.biliPath = dirUri;
	            	$scope.refresh();
	            } else {
	            	$cordovaToast.show('文件夹位置不正确', 'short', 'center')
	            };
			})
	}
})